##// END OF EJS Templates
error on indentation o
vidal -
r757:b039913c8017
parent child
Show More
@@ -1,922 +1,922
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=3P}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # APT settings
97 97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 98 APT_PROXY=${APT_PROXY:=""}
99 99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 100 # Packages required in the chroot build environment
101 101 APT_INCLUDES=${APT_INCLUDES:=""}
102 102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 103 # Packages to exclude from chroot build environment
104 104 APT_EXCLUDES=${APT_EXCLUDES:=""}
105 105
106 106 # General settings
107 107 SET_ARCH=${SET_ARCH:=32}
108 108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 111 EXPANDROOT=${EXPANDROOT:=true}
112 112
113 113 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 115 ENABLE_USER=${ENABLE_USER:=true}
116 116 USER_NAME=${USER_NAME:="pi"}
117 117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118 118
119 119 # Keyboard settings
120 120 XKB_MODEL=${XKB_MODEL:=""}
121 121 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 122 XKB_VARIANT=${XKB_VARIANT:=""}
123 123 XKB_OPTIONS=${XKB_OPTIONS:=""}
124 124
125 125 # Networking settings:
126 126 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131 131
132 132 # Network settings (DHCP)
133 133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135 135
136 136 # Network settings (static)
137 137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144 144
145 145 # Networking settings (WIFI):
146 146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148 148
149 149 # Network settings (static)
150 150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157 157
158 158 # Feature settings
159 159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 163 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 164 ENABLE_I2C=${ENABLE_I2C:=false}
165 165 ENABLE_SPI=${ENABLE_SPI:=false}
166 166
167 167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 169 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 176 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179 179
180 180 # Advanced settings
181 181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 183 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 188 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 194 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
195 195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
196 196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
197 197 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
198 198 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
199 199
200 200 # SSH settings
201 201 SSH_ENABLE=${SSH_ENABLE:=true}
202 202 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
203 203 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
204 204 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
205 205 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
206 206 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
207 207
208 208 # Kernel compilation settings
209 209 BUILD_KERNEL=${BUILD_KERNEL:=true}
210 210 KERNEL_THREADS=${KERNEL_THREADS:=1}
211 211 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
212 212 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
213 213 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
214 214 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
215 215 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
216 216 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
217 217 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
218 218 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
219 219 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
220 220 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
221 221 # Firmware directory: Blank if download from github
222 222 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
223 223 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
224 224 KERNEL_NF=${KERNEL_NF:=false}
225 225 KERNEL_VIRT=${KERNEL_VIRT:=false}
226 226 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
227 227 KERNEL_BPF=${KERNEL_BPF:=false}
228 228 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
229 229 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
230 230 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
231 231 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
232 232 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
233 233
234 234 # Reduce disk usage settings
235 235 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
236 236 REDUCE_APT=${REDUCE_APT:=true}
237 237 REDUCE_DOC=${REDUCE_DOC:=false}
238 238 REDUCE_MAN=${REDUCE_MAN:=false}
239 239 REDUCE_VIM=${REDUCE_VIM:=false}
240 240 REDUCE_BASH=${REDUCE_BASH:=false}
241 241 REDUCE_HWDB=${REDUCE_HWDB:=false}
242 242 REDUCE_SSHD=${REDUCE_SSHD:=false}
243 243 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
244 244 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
245 245
246 246 # Encrypted filesystem settings
247 247 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
248 248 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
249 249 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
250 250 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
251 251 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
252 252 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
253 253 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
254 254 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
255 255 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
256 256 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
257 257
258 258 # Packages required for bootstrapping
259 259 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
260 260 MISSING_PACKAGES=""
261 261
262 262 # Packages installed for c/c++ build environment in chroot (keep empty)
263 263 COMPILER_PACKAGES=""
264 264
265 265 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
266 266 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
267 267 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
268 268 APT_PROXY=http://127.0.0.1:3142/
269 269 fi
270 270
271 271 # Setup architecture specific settings
272 272 if [ -n "$SET_ARCH" ] ; then
273 273 ## 64-bit configuration
274 274 if [ "$SET_ARCH" = 64 ] ; then
275 275 ### General 64-bit depended settings
276 276 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
277 277 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
278 278 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
279 279
280 280 ### Raspberry Pi 64-bit model specific settings
281 281 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
282 282 if [ "$RPI_MODEL" != 4 ] ; then
283 283 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
284 284 else
285 285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
286 286 fi
287 287
288 288 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
289 289 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
290 290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
291 291 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
292 292
293 293 else
294 294 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
295 295 exit 1
296 296 fi
297 297 fi
298 298
299 299 ## 32-bit configuration
300 300 if [ "$SET_ARCH" = 32 ] ; then
301 301 ### General 32-bit dependend settings
302 302 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
303 303 KERNEL_ARCH=${KERNEL_ARCH:=arm}
304 304 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
305 305
306 306 ### Raspberry Pi (0-1P) model specific settings
307 307 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
308 308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
309 309 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
310 310 RELEASE_ARCH=${RELEASE_ARCH:=armel}
311 311 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
312 312 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
313 313 if [ $ENABLE_XORG = true ] ; then
314 314 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
315 315 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
316 316 read -r confirm
317 317 if [ "$confirm" = "y" ] ; then
318 318 $RELEASE = "stretch"
319 319 fi
320 320 fi
321 321 fi
322 322 fi
323 323 ### Raspberry Pi (2-4) model specific settings
324 324 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
325 325 if [ "$RPI_MODEL" != 4 ] ; then
326 326 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
327 327 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
328 328 else
329 329 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
330 330 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
331 331 fi
332 332
333 333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
334 334 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
335 335
336 336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
337 337 fi
338 338 fi
339 339
340 340 # SET_ARCH not set
341 341 else
342 342 echo "error: Please set '32' or '64' as value for SET_ARCH"
343 343 exit 1
344 344 fi
345 345 # Device specific configuration and U-Boot configuration
346 346 case "$RPI_MODEL" in
347 347 0)
348 348 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
349 349 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
350 350 ;;
351 351 1)
352 352 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
353 353 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
354 354 ;;
355 355 1P)
356 356 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
357 357 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
358 358 ;;
359 359 2)
360 360 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
361 361 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
362 362 ;;
363 363 3)
364 364 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
365 365 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
366 366 ;;
367 367 3P)
368 368 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
369 369 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
370 370 ;;
371 371 4)
372 372 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
373 373 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
374 374 ;;
375 375 *)
376 376 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
377 377 exit 1
378 378 ;;
379 379 esac
380 380
381 381 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
382 382 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
383 383 ## Include bluetooth packages on supported boards
384 384 if [ "$ENABLE_BLUETOOTH" = true ] ; then
385 385 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
386 386 fi
387 387 if [ "$ENABLE_WIRELESS" = true ] ; then
388 388 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
389 389 fi
390 390 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
391 391 else
392 392 ## Check if the internal wireless interface is not supported by the RPi model
393 393 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
394 394 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
395 395 exit 1
396 396 fi
397 397 fi
398 398
399 399 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
400 400 echo "error: You have to compile kernel sources, if you want to enable nexmon"
401 401 exit 1
402 402 fi
403 403
404 404 # Prepare date string for default image file name
405 405 DATE="$(date +%Y-%m-%d)"
406 406 if [ -z "$KERNEL_BRANCH" ] ; then
407 407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
408 408 else
409 409 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
410 410 fi
411 411
412 412 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
413 413 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
414 414 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
415 415 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
416 416 exit 1
417 417 fi
418 418 fi
419 419
420 420 # Add cmake to compile videocore sources
421 421 if [ "$ENABLE_VIDEOCORE" = true ] ; then
422 422 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
423 423 fi
424 424
425 425 # Add deps for nexmon
426 426 if [ "$ENABLE_NEXMON" = true ] ; then
427 427 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
428 428 fi
429 429
430 430 # Add libncurses5 to enable kernel menuconfig
431 431 if [ "$KERNEL_MENUCONFIG" = true ] ; then
432 432 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
433 433 fi
434 434
435 435 # Add ccache compiler cache for (faster) kernel cross (re)compilation
436 436 if [ "$KERNEL_CCACHE" = true ] ; then
437 437 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
438 438 fi
439 439
440 440 # Add cryptsetup package to enable filesystem encryption
441 441 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
442 442 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
443 443 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
444 444
445 445 ## If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
446 446 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
447 447 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
448 448 fi
449 449
450 450 if [ -z "$CRYPTFS_PASSWORD" ] ; then
451 451 echo "error: no password defined (CRYPTFS_PASSWORD)!"
452 452 exit 1
453 453 fi
454 454 ENABLE_INITRAMFS=true
455 455 fi
456 456
457 457 # Add initramfs generation tools
458 458 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
459 459 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
460 460 fi
461 461
462 462 # Add device-tree-compiler required for building the U-Boot bootloader
463 463 if [ "$ENABLE_UBOOT" = true ] ; then
464 464 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
465 465 fi
466 466
467 467 if [ "$ENABLE_USBBOOT" = true ] ; then
468 468 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
469 469 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
470 470 exit 1
471 471 fi
472 472 fi
473 473
474 474 # Check if root SSH (v2) public key file exists
475 475 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
476 476 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
477 477 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
478 478 exit 1
479 479 fi
480 480 fi
481 481
482 482 # Check if $USER_NAME SSH (v2) public key file exists
483 483 if [ -n "$SSH_USER_PUB_KEY" ] ; then
484 484 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
485 485 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
486 486 exit 1
487 487 fi
488 488 fi
489 489
490 490 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
491 491 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
492 492 exit 1
493 493 fi
494 494
495 495 # Check if all required packages are installed on the build system
496 496 for package in $REQUIRED_PACKAGES ; do
497 497 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
498 498 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
499 499 fi
500 500 done
501 501
502 502 # If there are missing packages ask confirmation for install, or exit
503 503 if [ -n "$MISSING_PACKAGES" ] ; then
504 504 echo "the following packages needed by this script are not installed:"
505 505 echo "$MISSING_PACKAGES"
506 506
507 507 printf "\ndo you want to install the missing packages right now? [y/n] "
508 508 read -r confirm
509 509 [ "$confirm" != "y" ] && exit 1
510 510
511 511 ## Make sure all missing required packages are installed
512 512 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
513 513 fi
514 514
515 515 # Check if ./bootstrap.d directory exists
516 516 if [ ! -d "./bootstrap.d/" ] ; then
517 517 echo "error: './bootstrap.d' required directory not found!"
518 518 exit 1
519 519 fi
520 520
521 521 # Check if ./files directory exists
522 522 if [ ! -d "./files/" ] ; then
523 523 echo "error: './files' required directory not found!"
524 524 exit 1
525 525 fi
526 526
527 527 # Check if specified KERNELSRC_DIR directory exists
528 528 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
529 529 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
530 530 exit 1
531 531 fi
532 532
533 533 # Check if specified UBOOTSRC_DIR directory exists
534 534 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
535 535 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
536 536 exit 1
537 537 fi
538 538
539 539 # Check if specified VIDEOCORESRC_DIR directory exists
540 540 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
541 541 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
542 542 exit 1
543 543 fi
544 544
545 545 # Check if specified FBTURBOSRC_DIR directory exists
546 546 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
547 547 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
548 548 exit 1
549 549 fi
550 550
551 551 # Check if specified NEXMONSRC_DIR directory exists
552 552 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
553 553 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
554 554 exit 1
555 555 fi
556 556
557 557 # Check if specified CHROOT_SCRIPTS directory exists
558 558 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
559 559 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
560 560 exit 1
561 561 fi
562 562
563 563 # Check if specified device mapping already exists (will be used by cryptsetup)
564 564 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
565 565 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
566 566 exit 1
567 567 fi
568 568
569 569 # Don't clobber an old build
570 570 if [ -e "$BUILDDIR" ] ; then
571 571 echo "error: directory ${BUILDDIR} already exists, not proceeding"
572 572 exit 1
573 573 fi
574 574
575 575 # Setup chroot directory
576 576 mkdir -p "${R}"
577 577
578 578 # Check if build directory has enough of free disk space >512MB
579 579 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
580 580 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
581 581 exit 1
582 582 fi
583 583
584 584 set -x
585 585
586 586 # Call "cleanup" function on various signals and errors
587 587 trap cleanup 0 1 2 3 6
588 588
589 589 # Add required packages for the minbase installation
590 590 if [ "$ENABLE_MINBASE" = true ] ; then
591 591 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
592 592 fi
593 593
594 594 # Add parted package, required to get partprobe utility
595 595 if [ "$EXPANDROOT" = true ] ; then
596 596 APT_INCLUDES="${APT_INCLUDES},parted"
597 597 fi
598 598
599 599 # Add dphys-swapfile package, required to enable swap
600 600 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
601 601 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
602 602 fi
603 603
604 604 # Add dbus package, recommended if using systemd
605 605 if [ "$ENABLE_DBUS" = true ] ; then
606 606 APT_INCLUDES="${APT_INCLUDES},dbus"
607 607 fi
608 608
609 609 # Add iptables IPv4/IPv6 package
610 610 if [ "$ENABLE_IPTABLES" = true ] ; then
611 611 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
612 612 fi
613 613 # Add apparmor for KERNEL_SECURITY
614 614 if [ "$KERNEL_SECURITY" = true ] ; then
615 615 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
616 616 fi
617 617
618 618 # Add openssh server package
619 619 if [ "$SSH_ENABLE" = true ] ; then
620 620 APT_INCLUDES="${APT_INCLUDES},openssh-server"
621 621 fi
622 622
623 623 # Add alsa-utils package
624 624 if [ "$ENABLE_SOUND" = true ] ; then
625 625 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
626 626 fi
627 627
628 628 # Add rng-tools package
629 629 if [ "$ENABLE_HWRANDOM" = true ] ; then
630 630 APT_INCLUDES="${APT_INCLUDES},rng-tools"
631 631 fi
632 632
633 633 # Add fbturbo video driver
634 634 if [ "$ENABLE_FBTURBO" = true ] ; then
635 635 # Enable xorg package dependencies
636 636 ENABLE_XORG=true
637 637 fi
638 638
639 639 # Add user defined window manager package
640 640 if [ -n "$ENABLE_WM" ] ; then
641 641 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
642 642
643 643 # Enable xorg package dependencies
644 644 ENABLE_XORG=true
645 645 fi
646 646
647 647 # Add xorg package
648 648 if [ "$ENABLE_XORG" = true ] ; then
649 649 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
650 650 fi
651 651
652 652 # Replace selected packages with smaller clones
653 653 if [ "$ENABLE_REDUCE" = true ] ; then
654 654 ## Add levee package instead of vim-tiny
655 655 if [ "$REDUCE_VIM" = true ] ; then
656 656 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
657 657 fi
658 658
659 659 ## Add dropbear package instead of openssh-server
660 660 if [ "$REDUCE_SSHD" = true ] ; then
661 661 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
662 662 fi
663 663 fi
664 664
665 665 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
666 666 if [ "$ENABLE_SYSVINIT" = false ] ; then
667 667 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
668 668 fi
669 669
670 670 # Configure kernel sources if no KERNELSRC_DIR
671 671 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
672 672 KERNELSRC_CONFIG=true
673 673 fi
674 674
675 675 # Configure reduced kernel
676 676 if [ "$KERNEL_REDUCE" = true ] ; then
677 677 KERNELSRC_CONFIG=false
678 678 fi
679 679
680 680 # Configure qemu compatible kernel
681 681 if [ "$ENABLE_QEMU" = true ] ; then
682 682 DTB_FILE=vexpress-v2p-ca15_a7.dtb
683 683 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
684 684 KERNEL_DEFCONFIG="vexpress_defconfig"
685 685 if [ "$KERNEL_MENUCONFIG" = false ] ; then
686 686 KERNEL_OLDDEFCONFIG=true
687 687 fi
688 688 fi
689 689
690 690 # Execute bootstrap scripts
691 691 for SCRIPT in bootstrap.d/*.sh; do
692 692 head -n 3 "$SCRIPT"
693 693 . "$SCRIPT"
694 694 done
695 695
696 696 ## Execute custom bootstrap scripts
697 697 if [ -d "custom.d" ] ; then
698 698 for SCRIPT in custom.d/*.sh; do
699 699 . "$SCRIPT"
700 700 done
701 701 fi
702 702
703 703 # Execute custom scripts inside the chroot
704 704 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
705 705 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
706 chroot_exec /bin/bash -x <<'EOF'
706 chroot_exec /bin/bash -x << EOF
707 707 for SCRIPT in /chroot_scripts/* ; do
708 708 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
709 709 $SCRIPT
710 710 fi
711 711 done
712 712 EOF
713 713 rm -rf "${R}/chroot_scripts"
714 714 fi
715 715
716 716 # Remove c/c++ build environment from the chroot
717 717 chroot_remove_cc
718 718
719 719 # Generate required machine-id
720 720 MACHINE_ID=$(dbus-uuidgen)
721 721 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
722 722 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
723 723
724 724 # APT Cleanup
725 725 chroot_exec apt-get -y clean
726 726 chroot_exec apt-get -y autoclean
727 727 chroot_exec apt-get -y autoremove
728 728
729 729 # Unmount mounted filesystems
730 730 umount -l "${R}/proc"
731 731 umount -l "${R}/sys"
732 732
733 733 # Clean up directories
734 734 rm -rf "${R}/run/*"
735 735 rm -rf "${R}/tmp/*"
736 736
737 737 # Clean up APT proxy settings
738 738 if [ "$KEEP_APT_PROXY" = false ] ; then
739 739 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
740 740 fi
741 741
742 742 # Clean up files
743 743 rm -f "${ETC_DIR}/ssh/ssh_host_*"
744 744 rm -f "${ETC_DIR}/dropbear/dropbear_*"
745 745 rm -f "${ETC_DIR}/apt/sources.list.save"
746 746 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
747 747 rm -f "${ETC_DIR}/*-"
748 748 rm -f "${ETC_DIR}/resolv.conf"
749 749 rm -f "${R}/root/.bash_history"
750 750 rm -f "${R}/var/lib/urandom/random-seed"
751 751 rm -f "${R}/initrd.img"
752 752 rm -f "${R}/vmlinuz"
753 753 rm -f "${R}${QEMU_BINARY}"
754 754
755 755 if [ "$ENABLE_QEMU" = true ] ; then
756 756 # Setup QEMU directory
757 757 mkdir "${BASEDIR}/qemu"
758 758
759 759 # Copy kernel image to QEMU directory
760 760 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
761 761
762 762 # Copy kernel config to QEMU directory
763 763 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
764 764
765 765 # Copy kernel dtbs to QEMU directory
766 766 for dtb in "${BOOT_DIR}/"*.dtb ; do
767 767 if [ -f "${dtb}" ] ; then
768 768 install_readonly "${dtb}" "${BASEDIR}/qemu/"
769 769 fi
770 770 done
771 771
772 772 # Copy kernel overlays to QEMU directory
773 773 if [ -d "${BOOT_DIR}/overlays" ] ; then
774 774 # Setup overlays dtbs directory
775 775 mkdir "${BASEDIR}/qemu/overlays"
776 776
777 777 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
778 778 if [ -f "${dtb}" ] ; then
779 779 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
780 780 fi
781 781 done
782 782 fi
783 783
784 784 # Copy u-boot files to QEMU directory
785 785 if [ "$ENABLE_UBOOT" = true ] ; then
786 786 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
787 787 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
788 788 fi
789 789 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
790 790 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
791 791 fi
792 792 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
793 793 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
794 794 fi
795 795 fi
796 796
797 797 # Copy initramfs to QEMU directory
798 798 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
799 799 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
800 800 fi
801 801 fi
802 802
803 803 # Calculate size of the chroot directory in KB
804 804 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
805 805
806 806 # Calculate the amount of needed 512 Byte sectors
807 807 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
808 808 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
809 809 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
810 810
811 811 # The root partition is EXT4
812 812 # This means more space than the actual used space of the chroot is used.
813 813 # As overhead for journaling and reserved blocks 35% are added.
814 814 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
815 815
816 816 # Calculate required image size in 512 Byte sectors
817 817 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
818 818
819 819 # Prepare image file
820 820 if [ "$ENABLE_SPLITFS" = true ] ; then
821 821 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
822 822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
823 823 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
824 824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
825 825
826 826 # Write firmware/boot partition tables
827 827 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
828 828 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
829 829 EOM
830 830
831 831 # Write root partition table
832 832 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
833 833 ${TABLE_SECTORS},${ROOT_SECTORS},83
834 834 EOM
835 835
836 836 # Setup temporary loop devices
837 837 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
838 838 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
839 839 else # ENABLE_SPLITFS=false
840 840 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
841 841 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
842 842
843 843 # Write partition table
844 844 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
845 845 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
846 846 ${ROOT_OFFSET},${ROOT_SECTORS},83
847 847 EOM
848 848
849 849 # Setup temporary loop devices
850 850 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
851 851 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
852 852 fi
853 853
854 854 if [ "$ENABLE_CRYPTFS" = true ] ; then
855 855 # Create dummy ext4 fs
856 856 mkfs.ext4 "$ROOT_LOOP"
857 857
858 858 # Setup password keyfile
859 859 touch .password
860 860 chmod 600 .password
861 861 echo -n ${CRYPTFS_PASSWORD} > .password
862 862
863 863 # Initialize encrypted partition
864 864 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
865 865
866 866 # Open encrypted partition and setup mapping
867 867 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
868 868
869 869 # Secure delete password keyfile
870 870 shred -zu .password
871 871
872 872 # Update temporary loop device
873 873 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
874 874
875 875 # Wipe encrypted partition (encryption cipher is used for randomness)
876 876 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
877 877 fi
878 878
879 879 # Build filesystems
880 880 mkfs.vfat "$FRMW_LOOP"
881 881 mkfs.ext4 "$ROOT_LOOP"
882 882
883 883 # Mount the temporary loop devices
884 884 mkdir -p "$BUILDDIR/mount"
885 885 mount "$ROOT_LOOP" "$BUILDDIR/mount"
886 886
887 887 mkdir -p "$BUILDDIR/mount/boot/firmware"
888 888 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
889 889
890 890 # Copy all files from the chroot to the loop device mount point directory
891 891 rsync -a "${R}/" "$BUILDDIR/mount/"
892 892
893 893 # Unmount all temporary loop devices and mount points
894 894 cleanup
895 895
896 896 # Create block map file(s) of image(s)
897 897 if [ "$ENABLE_SPLITFS" = true ] ; then
898 898 # Create block map files for "bmaptool"
899 899 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
900 900 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
901 901
902 902 # Image was successfully created
903 903 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
904 904 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
905 905 else
906 906 # Create block map file for "bmaptool"
907 907 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
908 908
909 909 # Image was successfully created
910 910 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
911 911
912 912 # Create qemu qcow2 image
913 913 if [ "$ENABLE_QEMU" = true ] ; then
914 914 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
915 915 QEMU_SIZE=16G
916 916
917 917 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
918 918 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
919 919
920 920 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
921 921 fi
922 922 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant